7a22d42c414bfb84f771418721a0f2e94e3b02e1
[distro-setup] / btrbk-run
1 #!/bin/bash
2
3 # Configure & run btrbk & related work on Ian's computers.
4 # Copyright (C) 2024 Ian Kelling
5
6 # This program is free software: you can redistribute it and/or modify
7 # it under the terms of the GNU General Public License as published by
8 # the Free Software Foundation, either version 3 of the License, or
9 # (at your option) any later version.
10
11 # This program is distributed in the hope that it will be useful,
12 # but WITHOUT ANY WARRANTY; without even the implied warranty of
13 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
14 # GNU General Public License for more details.
15
16 # You should have received a copy of the GNU General Public License
17 # along with this program. If not, see <http://www.gnu.org/licenses/>.
18
19 # SPDX-License-Identifier: GPL-3.0-or-later
20
21
22 # todo: if we cancel in the middle of a btrfs send, then run again
23 # immediately, the received subvolume doesn't get a Received UUID:
24 # field, and we won't mount it. Need to figure out a solution that will
25 # fix this.
26
27
28 [[ $EUID == 0 ]] || exec sudo -E "${BASH_SOURCE[0]}" "$@"
29
30 set -e; . /usr/local/lib/bash-bear; set +e
31 shopt -s nullglob
32
33 usage() {
34 cat <<'EOF'
35 btrbk-run [OPTIONS] [run|resume|archive]
36 usually -t TARGET_HOST or -s SOURCE_HOST
37
38 Note, at source location, intentionally not executable, run and read
39 install-my-scripts.
40
41 EOF
42 echo "top of script file:"
43 sed -n '1,/^[# ]*end command line/{p;b};q' "$0"
44 exit $1
45 }
46
47
48 pre=btrbk-run
49
50 script_name="${BASH_SOURCE[0]}"
51 script_name="${script_name##*/}"
52 d() {
53 if $dry_run || $conf_only; then
54 printf "$pre dry-run: %s\n" "$*"
55 else
56 printf "$pre running: %s\n" "$*"
57 "$@"
58 fi
59 }
60 m() { if $verbose; then printf "$pre %s\n" "$*"; fi; "$@"; }
61 e() { printf "$pre %s\n" "$*"; }
62 die() { printf "$pre error: %s\n" "$*" >&2; echo "$pre exiting with status 1" >&2; exit 1; }
63 mexit() { echo "$pre exiting with status $1"; exit $1; }
64
65 uninstalled-file-die() {
66 die "uninstalled file $1. run install-my-scripts or rerun with -f"
67 }
68
69 set-location() {
70 case $HOSTNAME in
71 kw)
72 at_work=true
73 ;;
74 kd|frodo)
75 at_home=true
76 ;;
77 x2|x3|sy)
78 if [[ $(dig +short @10.2.0.1 -x 10.2.0.2 2>&1 ||:) == kd.b8.nz. ]] \
79 && ip n show 10.2.0.1 | grep . &>/dev/null; then
80 at_home=true
81 elif ping -q -c1 -w1 hal.office.fsf.org &>/dev/null \
82 && ip n show 192.168.0.26 | grep . &>/dev/null; then
83 at_work=true
84 fi
85 ;;
86 esac
87 }
88
89 exit-if-no-default-targets() {
90 if ! $force && [[ $HOSTNAME != "$MAIL_HOST" ]]; then
91 echo "MAIL_HOST=$MAIL_HOST, nothing to do"
92 mexit 0
93 fi
94 case $HOSTNAME in
95 kw|kd|frodo|x2|x3|sy) : ;;
96 *)
97 die "error: no default targets for this host, use -t"
98 ;;
99 esac
100 }
101
102 add-x3-target() {
103 # main work machine
104 if ping -q -c1 -w1 x3.office.fsf.org &>/dev/null; then
105 targets+=(x3.office.fsf.org)
106 elif ping -q -c1 -w1 $h.b8.nz &>/dev/null; then
107 # in case we took it home
108 targets+=(x3.b8.nz)
109 elif ping -q -c1 -w1 ${h}w.b8.nz &>/dev/null; then
110 targets+=(x3w.b8.nz)
111 else
112 targets+=(x3wg.b8.nz)
113 fi
114 }
115
116 add-wireless-target-h() {
117 if ping -q -c1 -w1 $h.b8.nz &>/dev/null; then
118 targets+=($h.b8.nz)
119 elif ping -q -c1 -w1 ${h}w.b8.nz &>/dev/null; then
120 targets+=(${h}w.b8.nz)
121 fi
122 }
123
124 qconf() {
125 case $sub in
126 q)
127 # q has sensitive data i dont want to backup for so long
128 cat >>/etc/btrbk$conf_suf.conf <<EOF
129 snapshot_preserve $q_preserve
130 snapshot_preserve_min 2h
131 snapshot_dir btrbk
132 target_preserve $q_preserve
133 target_preserve_min 2h
134 EOF
135 ;;
136 esac
137
138 }
139
140
141 # latest $MAIL_HOST
142 if [[ -e /b/bash_unpublished/source-state ]]; then
143 source /b/bash_unpublished/source-state
144 fi
145
146 # note q is owned by root:1000
147
148 mountpoints=()
149
150 rsync_mountpoint=/q
151
152 ret=0
153 # default options
154 conf_only=false
155 dry_run=false # mostly for testing
156 rate_limit=no
157 verbose=true; verbose_arg=-v
158 force=false
159 if [[ $INVOCATION_ID ]]; then
160 # INVOCATION_ID means running as a systemd service. we cant show progress in this case,
161 # but if we pass the arg, it will insert mbuffer into the command.
162 progress_arg=
163 else
164 progress_arg="--progress"
165 fi
166 incremental_strict=false
167 pull_reexec=false
168
169 default_args_file=/etc/btrbk-run.conf
170 if [[ -s $default_args_file ]]; then
171 # shellcheck disable=SC2046 # we want word splitting
172 set -- $(< $default_args_file) "$@"
173 # i havent used this feature yet, so warn about it
174 echo "$0: warning: default btrbk-run options set in $default_args_file (sleeping 5 seconds):"
175 cat $default_args_file
176 sleep 5
177 fi
178
179 once_args_file=/etc/btrbk-run-once.conf
180 if mv -f $once_args_file $once_args_file-tmp 2> >(sed '/No such file or directory/d'); then
181 # shellcheck disable=SC2046 # we want word splitting
182 set -- $(< $once_args_file-tmp) "$@"
183 # i havent used this feature yet, so warn about it
184 echo "$0: btrbk-run options set in $once_args_file:"
185 cat $once_args_file-tmp
186 rm -f $once_args_file-tmp
187 fi
188
189
190 targets=()
191 early=false
192 fast=false
193 kd_spread=false
194 check_installed=false
195 orig_args=("$@")
196 temp=$(getopt -l check-installed,fast,pull-reexec,help 23cefikl:m:npqrs:t:vh "$@") || usage 1
197 eval set -- "$temp"
198 while true; do
199 case $1 in
200 # for the rare case we want to run multiple instances at the same time
201 -2) conf_suf=2 ;;
202 -3) conf_suf=3 ;;
203 # only creates the config file, does not run btrbk
204 -c) conf_only=true ;;
205 --check-installed)
206 check_installed=true
207 ;;
208 # quit early, just btrbk, no extra remounting etc.
209 -e) early=true ;;
210 # avoids some default behaviors:
211 # - no skipping hosts where xprintidle haven't been idle recently
212 # - exit if we can't ssh to 1 or more hosts
213 # - still set default hosts despite MAIL_HOST status
214 -f) force=true ;;
215 # skip various checks. when we run twice in a row for
216 # switch mail-host, no need to repeat the same checks again.
217 --fast) fast=true ;;
218 -i) incremental_strict=true ;;
219 # note this implies resume and -p because it is just meant to make
220 # other hosts have the same snapshots, not do any expiry or new
221 # backups.
222 -k) kd_spread=true ;;
223 # bytes per second, suffix k m g
224 -l) rate_limit=$2; shift ;;
225 # Comma separated mountpoints to backup. This has defaults set below.
226 -m) IFS=, mountpoints=($2); unset IFS; shift ;;
227 -n) dry_run=true ;;
228 # preserve existing snapshots and backups
229 -p) preserve_arg=-p ;;
230 # internal option for rerunning under newer SOURCE_HOST version.
231 --pull-reexec) pull_reexec=true;;
232 # quiet
233 -q) verbose=false; verbose_arg=; progress_arg= ;;
234 # source host to receive a backup from
235 -s)
236 source=$2
237 bbksource=$source
238 if [[ $source == *:* ]]; then
239 bbksource="[$source]"
240 fi
241 shift
242 ;;
243 # target hosts to send to. empty is valid for just doing local
244 # snapshot. we have default hosts we will populate.
245 -t) IFS=, targets=($2); unset IFS; shift ;;
246 # verbose.
247 -v) verbose=true; verbose_arg=-v ;;
248 -h|--help) usage ;;
249 --) shift; break ;;
250 *) die "Internal error!" ;;
251 esac
252 shift
253 done
254
255 cmd_arg="$1"
256
257
258
259 if ! $force && { $check_installed || [[ ! $source ]]; } ; then
260 install_bin_files=(
261 mount-latest-subvol
262 check-subvol-stale
263 btrbk-run
264 )
265 for f in ${install_bin_files[@]}; do
266 if ! diff -q /a/bin/ds/$f /usr/local/bin/$f; then
267 uninstalled-file-die $f
268 fi
269 done
270 if ! diff -q /a/bin/bash-bear-trap/bash-bear /usr/local/lib/bash-bear; then
271 uninstalled-file-die err
272 fi
273 if $check_installed; then
274 exit 0
275 fi
276 fi
277
278
279 if $kd_spread; then
280 if [[ $cmd_arg && $cmd_arg != resume ]]; then
281 die "dont pass -k without resume or empty run arg"
282 fi
283 if [[ $HOSTNAME == "$MAIL_HOST" ]]; then
284 die "something went wrong, -k not meant to be run on MAIL_HOST"
285 fi
286 if [[ $HOSTNAME != kd ]]; then
287 die "something went wrong, -k only meant to run on kd"
288 fi
289 cmd_arg=resume
290 preserve_arg=-p
291 h=sy
292 add-wireless-target-h
293 fi
294
295 if [[ ! $cmd_arg ]]; then
296 cmd_arg=run
297 fi
298
299
300 std_preserve="36h 14d 8w 24m"
301 q_preserve="18h 14d 8w"
302
303 case $cmd_arg in
304 run|resume) : ;;
305
306 # This works better than the normal archive command. We have to
307 # specify the mount points, but that is what we are used to doing and
308 # we prefer it. Another difference is that archive works recursively
309 # and we don't care about that. Sometimes we may still want to run
310 # btrbk archive, but it doesn't even use the config file, so just
311 # run it directly, eg:
312 # time s btrbk -v archive /mnt/r7/amy/boot/btrbk ssh://bo/mnt/boot2/btrbk
313 archive)
314 cmd_arg=resume
315 std_preserve="999h 999d 999w 999m"
316 q_preserve="$std_preserve"
317 preserve_arg=-p
318 ;;
319 *) die "untested command arg" ;;
320 esac
321
322 if (( $# > 1 )); then
323 die: "only 1 nonoption arg is supported"
324 fi
325
326 if [[ -v targets && $source ]]; then
327 # note, this doesnt need to be the case, but
328 # we would need to think about it.
329 die "error: -t and -s are mutually exclusive"
330 fi
331
332 ### end options parsing
333
334 # remove path from earlier version of btrbk
335 rm -f /usr/sbin/btrbk
336 # note, this still works as intended if there is no /usr/bin/btrbk
337 if [[ /a/opt/btrbk/btrbk -nt /usr/bin/btrbk ]]; then
338 if [[ -e /b/distro-functions/src/package-manager-abstractions ]]; then
339 . /b/distro-functions/src/package-manager-abstractions
340 pi asciidoctor
341 fi
342 cd /a/opt/btrbk
343 m make install
344 cd /
345 fi
346
347 # TODO: i wonder if there should be an option to send to the default
348 # targets, plus any given on the command line.
349
350
351 at_work=false
352 at_home=false
353
354
355 # set default targets
356 if [[ ! -v targets && ! $source ]]; then
357 exit-if-no-default-targets
358 set-location
359 if $at_home; then
360 if ! $kd_spread && [[ $HOSTNAME != x3 ]]; then
361 add-x3-target
362 fi
363 if [[ $HOSTNAME != kd ]]; then
364 targets+=(kd.b8.nz)
365 fi
366 wireless_home_hosts=(
367 x2
368 sy
369 )
370 for h in ${wireless_home_hosts[@]}; do
371 if [[ $HOSTNAME != "$h" ]]; then
372 add-wireless-target-h
373 fi
374 done
375 elif $at_work; then
376 targets+=(i.b8.nz)
377 for h in x2 x3 kw; do
378 if [[ $HOSTNAME == "$h" ]]; then
379 continue
380 fi
381 if ping -q -c1 -w1 $h.office.fsf.org &>/dev/null; then
382 targets+=($h.office.fsf.org)
383 fi
384 done
385 else
386 targets+=(i.b8.nz)
387 fi
388 fi
389
390 if [[ ${mountpoints[0]} ]]; then
391 for mp in ${mountpoints[@]}; do
392 if [[ -e /nocow/btrfs-stale/$mp ]]; then
393 die "error: $mp is stale, mount-latest-subvol first"
394 fi
395 done
396 else
397 # set default mountpoints
398 if [[ ${targets[0]} == tp ]]; then
399 prospective_mps=(/a)
400 else
401 case $HOSTNAME in
402 *)
403 prospective_mps=()
404 if [[ $source ]]; then
405 source_state="$(ssh $source 'cat /a/bin/bash_unpublished/source-state; echo source_host=$HOSTNAME')"
406 eval "$source_state"
407 # shellcheck disable=SC2154 # assigned in the above eval.
408 if [[ $source_host == "$MAIL_HOST" ]]; then
409 prospective_mps+=(/o)
410 fi
411 if [[ $source_host == "$HOST2" ]]; then
412 prospective_mps+=(/a /qr /qd /q)
413 fi
414 else
415 if [[ $HOSTNAME == "$MAIL_HOST" ]]; then
416 prospective_mps+=(/o)
417 fi
418 if [[ $HOSTNAME == "$HOST2" ]]; then
419 prospective_mps+=(/a /qr /qd /q)
420 fi
421 if $kd_spread; then
422 prospective_mps=(/a /o /qr /qd /q)
423 fi
424 fi
425 # note: put q last just in case its specific retention options were to
426 # affect other config sections. I havent tested if that is the case.
427 ;;
428 esac
429 fi
430 for mp in ${prospective_mps[@]}; do # default mountpoints to sync
431 if [[ -e /nocow/btrfs-stale/$mp ]]; then
432 e "warning: $mp stale, not adding to default mountpoints"
433 continue
434 fi
435 if awk '{print $2}' /etc/fstab | grep -xF $mp &>/dev/null; then
436 mountpoints+=($mp)
437 fi
438 done
439 fi
440
441 tmp=$(( ${#mountpoints[@]} == 0 ))
442 if (( tmp )); then
443 die didnt get mountpoint arg and had no defaults
444 fi
445
446 ##### end command line parsing ########
447
448 #### begin pre-checks #####
449
450 # todo: this has a timing problem, since btrbk.timer could activate the service after this check.
451 if ! $fast && [[ $source ]]; then
452 if [[ $(ssh $source ps --no-headers -o comm 1) == systemd ]]; then
453 status=$(ssh $source systemctl is-active btrbk.service) || : # normally returns 3
454 case $status in
455 inactive|failed) : ;;
456 *)
457 echo "$0: error: btrbk is running on source. exiting out of caution"
458 mexit 1
459 esac
460 fi
461 fi
462
463 if ! command -v btrbk &>/dev/null; then
464 die "error: no btrbk binary found"
465 fi
466
467 if ! $pull_reexec && [[ $source ]] && $pulla && ! $force ; then
468 ssh root@$source btrbk-run --check-installed || exit 1
469 fi
470
471 #### end pre-checks #####
472
473
474
475 mkdir -p /var/log/btrbk
476 # The journal doesnt go back to my oldest backups, and I've found myself
477 # wanting older logs. Not going to bother expiring old logs, since it is
478 # fine if they go back years.
479 log_path=/var/log/btrbk/$(date +%F_%T%:::z).log
480 echo copying output to $log_path
481 exec &> >(pee cat 'ts "%F %T"|dd of='$log_path' status=none')
482
483 # print some non-default opts
484 if $verbose; then
485 opts_show=()
486 if ! $conf_only; then
487 opts_show+=(conf_only=true)
488 fi
489 if ! $dry_run; then
490 opts_show+=(dry_run=true)
491 fi
492 if [[ $rate_limit != no ]]; then
493 opts_show+=("rate_limit=$rate_limit")
494 fi
495 if [[ $cmd_arg != run ]]; then
496 opts_show+=(cmd_arg=$cmd_arg)
497 fi
498 if (( ${#opts_show[@]} >= 1 )); then
499 first=true
500 for opt in ${opts_show[@]}; do
501 if $first; then
502 printf "%s" "$opt"
503 else
504 printf " %s" "$opt"
505 fi
506 done
507 echo
508 fi
509 fi
510
511 if [[ -v targets ]]; then
512 echo "targets: ${targets[*]}"
513 fi
514
515 if [[ $source ]]; then
516 echo "source: $source"
517 fi
518
519 echo "mountpoints: ${mountpoints[*]}"
520
521
522 # pull_reexec stops us from getting into an infinite loop if there is some
523 # kind of weird problem
524 pulla=false
525 for m in "${mountpoints[@]}"; do
526 if [[ $m == /a ]]; then
527 pulla=true
528 break
529 fi
530 done
531
532 if ! $pull_reexec && [[ $source ]] && $pulla ; then
533 tmpf=$(mktemp)
534 m rsync -ra $source:/usr/local/bin/{mount-latest-subvol,check-subvol-stale} /usr/local/bin
535 m rsync -ra $source:/usr/local/lib/bash-bear /usr/local/lib
536 m scp $source:/a/bin/distro-setup/btrbk-run $tmpf
537 if ! diff -q $tmpf ${BASH_SOURCE[0]}; then
538 e "found different version on host $source. reexecing"
539 install -T $tmpf /usr/local/bin/btrbk-run
540 m /usr/local/bin/btrbk-run --pull-reexec "${orig_args[@]}"
541 mexit 0
542 fi
543 fi
544
545
546 if ! $fast; then
547 # if our mountpoints are from stale snapshots,
548 # it doesn't make sense to do a backup.
549 m check-subvol-stale ${mountpoints[@]} || die "found stale mountpoints in ${mountpoints[*]}"
550
551 # for an initial run, btrbk requires the dir to exist.
552 mkdir -p /mnt/{root,o}/btrbk
553 fi
554 local_zone=$(date +%z)
555
556 if [[ $source ]]; then
557 if $fast; then
558 zone=$local_zone
559 else
560 if ! zone=$(ssh root@$source date +%z); then
561 if $conf_only; then
562 echo "$0: warning: failed to ssh to root@$source"
563 else
564 die failed to ssh to root@$source
565 fi
566 fi
567 if [[ $zone != "$local_zone" ]]; then
568 die "error: dont confuse yourself with multiple time zones. $h has different timezone than localhost"
569 fi
570 fi
571 else
572
573 sshable=()
574 sshfail=()
575 for h in ${targets[@]}; do
576 if $fast || $conf_only; then
577 # Use some typical values in this case
578 root_size=$(( 1024 * 1024 * 2000 )) #2tb
579 percent_used=10
580 zone=$(date +%z)
581 elif remote_str=$(timeout -s 9 6 ssh root@$h "mkdir -p /mnt/root/btrbk /mnt/o/btrbk && date +%z && df --output=size,pcent / | tail -n1"); then
582 mapfile -t tmp_array <<<"$remote_str"
583 zone="${tmp_array[0]}"
584 IFS=" " read -r root_size percent_used <<<"${tmp_array[1]}"
585 percent_used=${percent_used%%%}
586
587 tmp=$(( ${#tmp_array[@]} != 2 ))
588 if (( tmp )); then
589 die "error: didnt get 2 lines in test ssh to target $h. investigate"
590 fi
591 case $percent_used in
592 [0-9]|[1-9][0-9]) : ;;
593 *)
594 die "error: didnt get percent disk use in test ssh to target $h. investigate"
595 ;;
596 esac
597 else
598 sshfail+=($h)
599 continue
600 fi
601
602 # we may be booted into a bootstrap fs or something
603 min_root_kb=$(( 1024 * 1024 * 200 )) # 200 gb
604 tmp=$(( root_size < min_root_kb ))
605 if (( tmp )); then
606 continue
607 fi
608
609 tmp=$(( percent_used >= 98 ))
610 if (( tmp )); then
611 die "error: filesystem on target $h is $percent_used % full"
612 fi
613
614 # on sy, xprintidle is resetting every 12 seconds even when not
615 # idle, i dunno why, instead we are checking if the screen is locked,
616 # which is good enough.
617 #
618 # This is a separate ssh because the command can fail and thatis ok.
619 if ! $force; then
620 locked=false
621 if lock_info=$(timeout -s 9 6 ssh $h DISPLAY=:0 xscreensaver-command -time); then
622 if [[ $lock_info != *non-blanked* ]]; then
623 locked=true
624 fi
625 else
626 locked=true
627 fi
628 if ! $locked; then
629 # Ignore this host. i sometimes use a non-main machine for
630 # testing or web browsing, knowing that everything will be wiped
631 # by the next backup, but I dont want it to happen as Im using
632 # it from cronjob.
633 e "warning: $h: seems to be actively in use, skipping for now"
634 continue
635 fi
636 fi
637 sshable+=($h)
638 if [[ $zone != "$local_zone" ]]; then
639 die "error: dont confuse yourself with multiple time zones. $h has different timezone than localhost"
640 fi
641 done
642 if [[ ! ${sshable[*]} ]] || { $force && [[ ${sshfail[*]} ]]; }; then
643 die "failed to ssh to hosts: ${sshfail[*]}"
644 else
645 if [[ ${sshfail[*]} ]]; then
646 ret=1
647 e "error: failed to ssh to ${sshfail[*]} but continuing with other hosts"
648 fi
649 targets=(${sshable[@]})
650 fi
651 fi
652
653
654 cat >/etc/btrbk$conf_suf.conf <<EOF
655 ssh_identity /q/root/h
656 #ssh_identity /root/.ssh/home
657
658 # Just a guess that local7 is a good facility to pick.
659 # It's a bit odd that the transaction log has to be logged to
660 # a file or syslog, while other output is sent to std out.
661 # The man does not mention a way for them to be together, but
662 # I dunno if setting a log level like warn might also output
663 # transaction info.
664 transaction_syslog local7
665
666 # trying this out
667 #stream_compress zstd
668
669 # so we only run one at a time
670 lockfile /var/lock/btrbk$conf_suf.lock
671
672 # default format of short does not accomidate hourly preservation setting
673 timestamp_format long-iso
674
675 # only make a snapshot if things have changed
676 snapshot_create onchange
677 # I could make this different from target_preserve,
678 # if one disk had less space.
679 # for now, keeping them equal.
680 snapshot_preserve $std_preserve
681 snapshot_preserve_min 6h
682 snapshot_dir btrbk
683 # so, total backups = ~58
684 target_preserve $std_preserve
685 target_preserve_min 6h
686
687 # it seems very likely that not doing this could result in clone source not found
688 # errors, for example when expiry happens differently on different hosts,
689 # also, as btrbk does by default, if a failed send happens, on the next run it
690 # will warn about a stray subvolume, but then create a backup of a newer subvol
691 # and use an older subvol as the parent.
692 incremental_prefs sao:1
693
694 # if something fails and it's not obvious, try doing
695 # btrbk -l debug -v dryrun
696
697 rate_limit $rate_limit
698 EOF
699
700 if $incremental_strict; then
701 cat >>/etc/btrbk$conf_suf.conf <<EOF
702 incremental strict
703 EOF
704 fi
705
706
707 # make /q be last
708 mp_count=${#mountpoints[@]}
709 for (( i=0; i < mp_count - 1 ; i++ )); do
710 if [[ ${mountpoints[i]} == /q ]]; then
711 unset "mountpoints[i]"
712 mountpoints+=(/q)
713 fi
714 done
715
716
717
718 snap_list_cmds=()
719 tg_snaps=()
720 declare -A source_snaps
721
722 for m in ${mountpoints[@]}; do
723 case $m in
724 /o)
725 vol=/mnt/o
726 ;;
727 *)
728 vol=/mnt/root
729 ;;
730 esac
731
732 sub=${m#/}
733 snap_list_cmds+=("echo $vol/btrbk/$sub.*;")
734
735 if [[ $source ]]; then
736 tmp_a=($vol/btrbk/$sub.*)
737 tg_snaps+=("${tmp_a[*]}")
738 cat >>/etc/btrbk$conf_suf.conf <<EOF
739 volume ssh://$bbksource$vol
740 subvolume $sub
741 EOF
742 qconf
743 cat >>/etc/btrbk$conf_suf.conf <<EOF
744 target send-receive $vol/btrbk
745 EOF
746 else # we have targets
747 for snap in "$vol/btrbk/$sub."*; do
748 source_snaps[$snap]=t
749 done
750
751 cat >>/etc/btrbk$conf_suf.conf <<EOF
752 volume $vol
753 subvolume $sub
754 EOF
755 qconf
756 for tg in ${targets[@]}; do
757 # handle ipv6
758 if [[ $tg == *:* ]]; then
759 tg="[$tg]"
760 fi
761 cat >>/etc/btrbk$conf_suf.conf <<EOF
762 target send-receive ssh://$tg$vol/btrbk
763 EOF
764 done
765 fi
766 done
767
768 # Delete any subvols on the receiving host that don't exist on the
769 # sending host. Otherwise, the receiving host could have snapshots that
770 # aren't on the sending side, and thus become odd leaf subvols, and then
771 # btrbk could try to use them when we sync back, creating a weird tree
772 # instead of linear parent/child relationship. Maybe this could lead to
773 # a missing source subvol error, so lets avoid it.
774
775 get-orphan-tg-snaps() {
776 orphan_tg_snaps=()
777 for (( i=0; i < ${#mountpoints[@]}; i++ )); do
778 orphan_start_count=${#orphan_tg_snaps[@]}
779 tg_snap_count=0
780 for tg_snap in ${tg_snaps[$i]}; do
781 tg_snap_count=$(( tg_snap_count + 1 ))
782 if [[ ! ${source_snaps[$tg_snap]} ]]; then
783 orphan_tg_snaps+=("$tg_snap")
784 fi
785 done
786 orphan_mp_count=$(( ${#orphan_tg_snaps[@]} - orphan_start_count ))
787 # sanity checking
788 tmp=$(( tg_snap_count > 1 && tg_snap_count == orphan_mp_count ))
789 if (( tmp )) ; then
790 die "something went wrong checking orphans on $tg: for mountpoint ${mountpoints[$i]}, $orphan_mp_count"
791 fi
792 done
793 }
794
795 if [[ $source ]]; then
796 for snap in $(ssh root@$source "shopt -s nullglob; ${snap_list_cmds[*]}"); do
797 source_snaps[$snap]=t
798 done
799 get-orphan-tg-snaps
800 tmp=$(( ${#orphan_tg_snaps[*]} >= 1 ))
801 if (( tmp )); then
802 d btrfs sub del ${orphan_tg_snaps[*]}
803 fi
804 else # we have targets
805 for tg in ${targets[@]}; do
806 tmp_str=$(ssh root@$tg "shopt -s nullglob; ${snap_list_cmds[*]}")
807 mapfile -t tg_snaps <<<"$tmp_str"
808 get-orphan-tg-snaps
809 tmp=$(( ${#orphan_tg_snaps[*]} >= 1 ))
810 if (( tmp )); then
811 d ssh root@$tg "btrfs sub del ${orphan_tg_snaps[*]}"
812 fi
813 done
814 fi
815
816 # todo: umount first to ensure we don't have any errors
817 # todo: do some kill fuser stuff to make umount more reliable
818
819
820 if $conf_only; then
821 mexit 0
822 fi
823
824
825
826 if $dry_run; then
827 m btrbk -c /etc/btrbk$conf_suf.conf -v -n $cmd_arg
828 mexit 0
829 fi
830 # -q and just using the syslog option seemed nice,
831 # but it doesn't show when a send has a parent and when it doesn't.
832 m btrbk -c /etc/btrbk$conf_suf.conf $preserve_arg $verbose_arg $progress_arg $cmd_arg
833
834 if $early; then
835 exit 0
836 fi
837
838 # todo: tp not valid anymore.
839 # if we have it, sync to systems which don't
840 if mountpoint $rsync_mountpoint >/dev/null; then
841 for tg in ${targets[@]}; do
842 case $tg in
843 tp)
844 dirs=(/p/c/machine_specific/tp)
845 for x in /p/c/machine_specific/*.hosts; do
846 if grep -qxF $tg $x; then
847 dirs+=(${x%.hosts})
848 fi
849 done
850 m rsync -aSAXPH --specials --devices --delete --relative ${dirs[@]} root@$tg:/
851 ;;
852 esac
853 done
854 fi
855
856 subvols=()
857 for mp in "${mountpoints[@]}"; do
858 subvols+=("${mp##*/}")
859 done
860 if [[ $source ]]; then
861 m mount-latest-subvol "${subvols[@]}"
862 else
863 for tg in ${targets[@]}; do
864 m /a/exe/mount-latest-remote "$tg" "${subvols[@]}" || ret=$?
865 done
866 fi
867
868 # todo, we get hostnames earlier, reuse that.
869 if [[ $ret == 0 ]]; then
870 for tg in ${targets[@]}; do
871 h=$(ssh $tg hostname)
872 if [[ $h == kd && $HOSTNAME == x3 && $HOSTNAME == "$MAIL_HOST" ]]; then
873 m ssh root@$tg 'btrbk-spread-wrap &>/dev/null </dev/null &'
874 fi
875 rsync --mkpath -a -f"- */" -f"+ *" /var/log/btrbk/ root@$tg:/var/log/btrbk/$tg
876 ssh root@$tg /usr/local/bin/mail-backup-clean
877 done
878 if [[ $source ]]; then
879 rsync --mkpath -a -f"- */" -f"+ *" $source:/var/log/btrbk/ /var/log/btrbk/$source
880 fi
881 fi
882
883 mexit $ret
884
885 # todo: move variable data we don't care about backing up
886 # to /nocow and symlink it.
887
888
889 # background on btrbk timezones. with short/long, timestamps use local time.
890 # for long, if your local time moves backwards, by moving timezones or
891 # for an hour when daylight savings changes it, you will temporarily get
892 # a more aggressive retention policy for the overlapping period, and
893 # vice versa for the opposite timezone move. The alternative is using
894 # long-iso, which puts timezone info into the timestamp, which means
895 # that instead of shifting time, you shift the start of day/week/month
896 # which is used for retention to your new local time, which means for
897 # example, if you moved forward by 8 hours, the daily/weekly/monthly
898 # retention will be 8 hours more aggressive since midnight is at a new
899 # time, unless you fake the timzeone using the TZ env variable.
900 # However, in the short term, there will be no inconsistencies.
901 # I don't see any problem with shifting when the day starts for
902 # retention, so I'm using long-iso.
903
904 # note to create a long-iso timestamp: date +%Y%m%dT%H%M%S%z